'use strict';

/**
 * Attach this to a ScrollingList's item to mask it
 * @moduleName ContainerMask
 * @snippet ContainerMask|constructor
ContainerMask({
    boundingBox: new Rectangle(-16, -16, 32, 32),
})
 */
bento.define('components/containermask', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/entity', 'bento/eventsystem', 'bento/utils', 'bento/tween', 'components/mask'], function (Bento, Vector2, Rectangle, Entity, EventSystem, Utils, Tween, Mask) {
    'use strict';

    var MaskBehavior = function MaskBehavior(settings) {
        var boundingBox = settings.boundingBox;
        var original = {
            x: boundingBox.x,
            y: boundingBox.y
        };
        var mask = new Mask({
            sprite: settings.sprite,
            boundingBox: boundingBox
        });
        var entity;
        return {
            name: 'maskBehavior',
            start: function start() {},
            attached: function attached(data) {
                entity = data.entity;
                entity.attach(mask);
            },
            removed: function removed() {
                entity.remove(mask);
            },
            update: function update() {}
        };
    };
    var ContainerMask = function ContainerMask(settings) {
        var entity;
        var component = {
            name: 'containerMask',
            start: function start() {},
            attached: function attached(data) {
                entity = data.entity;
            }
        };
        return component;
    };
    return ContainerMask;
});