'use strict';

bento.define('components/pixicounter', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/utils'], function (Bento, Vector2, Rectangle, Utils) {

    var PIXI = window.PIXI;

    var defaultStyle = {
        imageName: 'font-jua-104',
        chars: {
            '0': { x: 0 * 64, width: 64 },
            '1': { x: 1 * 64, width: 40 },
            '2': { x: 2 * 64, width: 62 },
            '3': { x: 3 * 64, width: 60 },
            '4': { x: 4 * 64, width: 62 },
            '5': { x: 5 * 64, width: 62 },
            '6': { x: 6 * 64, width: 62 },
            '7': { x: 7 * 64, width: 62 },
            '8': { x: 8 * 64, width: 62 },
            '9': { x: 9 * 64, width: 62 }
        }
    };

    return function (settings) {
        var _settings$name = settings.name,
            name = _settings$name === undefined ? 'pixiCounter' : _settings$name,
            _settings$position = settings.position,
            position = _settings$position === undefined ? new Vector2(0, 0) : _settings$position,
            _settings$text = settings.text,
            text = _settings$text === undefined ? '41528' : _settings$text,
            _settings$style = settings.style,
            style = _settings$style === undefined ? defaultStyle : _settings$style;
        var imageName = style.imageName,
            chars = style.chars;

        var keys = Object.keys(chars);

        var texture = Utils.newTexture(imageName);
        var height = texture.height;

        // the stuff below is wrong
        // .. let's leave this for another time :\

        var vertices = new Float32Array(keys.length * 4 * 2); // actually only needs to be made once
        var baseIndices = {}; // mapping from character to first of 4 x,y pairs (for corners ul, ur, dl, dr)

        for (var i = 0; i < keys.length; i++) {
            var k = keys[i];
            var _chars$k = chars[k],
                x = _chars$k.x,
                width = _chars$k.width;

            var j = i * 4 * 2;
            baseIndices[k] = j;
            vertices[j + 0] = x; // top left
            vertices[j + 1] = 0;
            vertices[j + 2] = x + width; // top right
            vertices[j + 3] = 0;
            vertices[j + 4] = x; // bottom left
            vertices[j + 5] = height;
            vertices[j + 6] = x + width; // bottom right
            vertices[j + 7] = height;
        }
        var uvs = new Float32Array(vertices);
        for (var _i = 0; _i < uvs.length; _i += 2) {
            uvs[_i] /= texture.width;
            uvs[_i + 1] /= texture.height;
        }

        var repaint = function repaint() {
            var indices = [];

            for (var _i2 = 0; _i2 < text.length; _i2++) {
                var _k = text.charAt[_i2];
                var baseIndex = baseIndices[_k];
            }
        };
        // let mesh = new PIXI.mesh.Mesh(texture, uvs, indices);

        var component = {
            name: name,
            position: position,
            draw: function draw(_ref) {
                // renderer.drawPixi(mesh);

                var renderer = _ref.renderer;
            }
        };
    };
});