'use strict';

/**
 * Test component: thing that constantly rotates
 * @moduleName Rotator
 * @snippet Rotator|constructor
Rotator({})
 */
bento.define('components/rotator', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/entity', 'bento/eventsystem', 'bento/utils', 'bento/tween'], function (Bento, Vector2, Rectangle, Entity, EventSystem, Utils, Tween) {
    'use strict';

    return function (settings) {
        var speed = settings.speed || Math.PI / 60;
        var entity;
        var component = {
            name: 'rotator',
            update: function update(data) {
                entity.rotation += speed;
            },
            attached: function attached(data) {
                entity = data.entity;
            }
        };
        return component;
    };
});