'use strict';

bento.define('components/wiggle', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/entity', 'bento/eventsystem', 'bento/utils', 'bento/tween'], function (Bento, Vector2, Rectangle, Entity, EventSystem, Utils, Tween) {
    return function (settings) {
        var entity;
        return {
            name: 'wiggle',
            frequency: settings.frequency || 0.1,
            amplitude: settings.amplitude || 0.012,
            destroy: function destroy() {
                entity.rotation = 0;
            },
            update: function update() {
                entity.rotation = Math.PI * this.amplitude * Math.sin(entity.timer * this.frequency);
            },
            attached: function attached(data) {
                entity = data.entity;
            }
        };
    };
});