'use strict';

bento.define('entities/gridbg', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/components/sprite', 'bento/entity', 'bento/eventsystem', 'bento/gui/text', 'bento/utils', 'bento/screen', 'bento/tween', 'globals'], function (Bento, Vector2, Rectangle, Sprite, Entity, EventSystem, Text, Utils, Screen, Tween, Globals) {
    return function (settings) {
        var PIXI = window.PIXI;

        var _settings$width = settings.width,
            width = _settings$width === undefined ? 280 : _settings$width,
            _settings$height = settings.height,
            height = _settings$height === undefined ? 496 : _settings$height;


        var scale = 0.125;
        var texture = Utils.newTexture('texture/grid-bg-thin');
        var sprite = new PIXI.extras.TilingSprite(texture, width / scale, height / scale);

        var entity = new Entity({
            z: Globals.Layers.GRID,
            name: 'gridBg',
            float: true,
            scale: new Vector2(scale, scale),
            position: new Vector2(-64, -96),
            components: {
                name: 'behavior',
                draw: function draw(_ref) {
                    var renderer = _ref.renderer;

                    renderer.drawPixi(sprite);
                }
            }
        });
        return entity;
    };
});