'use strict';

bento.define('entities/gui/fastforwardbutton', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/components/sprite', 'bento/components/clickable', 'bento/entity', 'bento/eventsystem', 'entities/gui/gamecounter', 'entities/gui/gamebutton', 'entities/gui/gametext', 'bento/gui/text', 'bento/utils', 'bento/screen', 'bento/tween', 'globals', 'bento/components/fill', 'bento/components/eventlistener'], function (Bento, Vector2, Rectangle, Sprite, Clickable, Entity, EventSystem, GameCounter, GameButton, GameText, Text, Utils, Screen, Tween, Globals, Fill, EventListener) {
    return function (settings) {
        var position = settings.position;


        var button = new GameButton({
            name: 'btnFastForward',
            position: position,
            float: true,
            imageName: 'fastforward',
            scale: new Vector2(0.6, 0.6),
            onClick: function onClick() {
                if (Bento.getGameSpeed() === 1) {
                    Bento.setGameSpeed(3);
                    button.attach(new Entity({
                        z: Globals.Layers.GUI,
                        name: 'fastForwardRing',
                        components: [new Sprite({
                            imageName: 'fastforward-ring',
                            originRelative: new Vector2(0.5, 0.5)
                        }), new Object({
                            name: 'behavior',
                            update: function update() {
                                this.parent.alpha = 0.6 + Math.sin(this.parent.ticker * 0.1) * 0.4;
                            }
                        })]
                    }));
                } else {
                    Bento.setGameSpeed(1);
                    button.removeByName('fastForwardRing');
                }
            },

            components: [new Object({
                name: 'behavior',
                destroy: function destroy() {
                    Bento.setGameSpeed(1);
                }
            }), new EventListener({
                eventName: 'win',
                onEvent: function onEvent() {
                    Bento.objects.remove(button);
                }
            })]
        });

        return button;
    };
});