'use strict';

/**
 * Module description
 * @moduleName FPSCounter
 * @snippet FPSCounter.snippet
FPSCounter({})
 */
bento.define('entities/gui/fpscounter', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/components/sprite', 'bento/components/clickable', 'bento/entity', 'bento/eventsystem', 'bento/gui/clickbutton', 'bento/gui/counter', 'bento/gui/text', 'bento/utils', 'bento/tween'], function (Bento, Vector2, Rectangle, Sprite, Clickable, Entity, EventSystem, ClickButton, Counter, Text, Utils, Tween) {
    'use strict';

    return function (settings) {
        var sampleEvery = 60;
        var totalTime = 0;
        var fpsText = new Text({
            z: 0,
            position: new Vector2(4, 0),
            text: '',
            font: 'font',
            fontSize: 8,
            fontColor: '#fff',
            align: 'left',
            textBaseline: 'top',
            ySpacing: 0,
            lineWidth: 1, // set to add an outline
            strokeStyle: '#000000',
            innerStroke: false,
            pixelStroke: false, // workaround for Cocoon bug
            maxWidth: undefined,
            maxHeight: undefined,
            linebreaks: true,
            drawDebug: false,
            components: []
        });
        var fpsCounter = new Entity({
            z: 10000000000000000000,
            name: 'fpsCounter',
            position: new Vector2(0, 0),
            scale: new Vector2(1, 1),
            alpha: 1,
            float: true,
            components: [{
                name: 'fpsCounterBehaviour',
                update: function update(data) {
                    totalTime += data.deltaT;
                    if (fpsCounter.ticker % sampleEvery === 0) {
                        var FPS = 1000 / (totalTime / sampleEvery);
                        fpsText.setText('FPS: ' + FPS.toFixed(2));
                        totalTime = 0;
                    }
                }
            }, fpsText]
        });
        return fpsCounter;
    };
});