'use strict';

bento.define('entities/gui/gamebutton', ['bento', 'bento/components/sprite', 'bento/math/vector2', 'bento/math/rectangle', 'bento/entity', 'bento/eventsystem', 'bento/utils', 'bento/gui/clickbutton', 'globals'], function (Bento, Sprite, Vector2, Rectangle, Entity, EventSystem, Utils, ClickButton, Globals) {
    return function (settings) {
        var _settings$z = settings.z,
            z = _settings$z === undefined ? Globals.Layers.GUI : _settings$z,
            _settings$name = settings.name,
            name = _settings$name === undefined ? 'gameButton' : _settings$name,
            position = settings.position,
            scale = settings.scale,
            _settings$float = settings.float,
            float = _settings$float === undefined ? true : _settings$float,
            _settings$imageName = settings.imageName,
            imageName = _settings$imageName === undefined ? 'gui/blank' : _settings$imageName,
            _settings$sfx = settings.sfx,
            sfx = _settings$sfx === undefined ? '' : _settings$sfx,
            _onClick = settings.onClick,
            _onButtonDown = settings.onButtonDown,
            _onButtonUp = settings.onButtonUp,
            components = settings.components;


        var btn = new ClickButton({
            z: z,
            name: name,
            sfx: sfx,
            imageName: imageName,
            frameCountX: 1,
            frameCountY: 1,
            position: position,
            scale: scale,
            updateWhenPaused: 0,
            float: float,
            components: components,
            onButtonDown: function onButtonDown() {
                btn.transform.y = 1;
                if (_onButtonDown) _onButtonDown();
            },
            onButtonUp: function onButtonUp() {
                btn.transform.y = 0;
                if (_onButtonUp) _onButtonUp();
            },
            onClick: function onClick() {
                if (_onClick) _onClick();
            }
        });
        return btn;
    };
});