'use strict';

bento.define('entities/gui/gametext', ['bento', 'bento/components/sprite', 'bento/math/vector2', 'bento/math/rectangle', 'bento/entity', 'bento/eventsystem', 'bento/utils', 'bento/tween', 'components/debug', 'components/wiggle', 'bento/gui/clickbutton', 'bento/gui/counter', 'bento/components/fill', 'bento/gui/text', 'globals'], function (Bento, Sprite, Vector2, Rectangle, Entity, EventSystem, Utils, Tween, Debug, Wiggle, ClickButton, Counter, Fill, Text, Globals) {
    return function (settings) {
        var _settings$z = settings.z,
            z = _settings$z === undefined ? Globals.Layers.GUI : _settings$z,
            position = settings.position,
            scale = settings.scale,
            text = settings.text,
            _settings$font = settings.font,
            font = _settings$font === undefined ? 'Jua-Regular' : _settings$font,
            _settings$fontSize = settings.fontSize,
            fontSize = _settings$fontSize === undefined ? 18 : _settings$fontSize,
            _settings$fontColor = settings.fontColor,
            fontColor = _settings$fontColor === undefined ? '#000000' : _settings$fontColor,
            _settings$align = settings.align,
            align = _settings$align === undefined ? 'center' : _settings$align,
            _settings$textBaselin = settings.textBaseline,
            textBaseline = _settings$textBaselin === undefined ? 'bottom' : _settings$textBaselin,
            maxHeight = settings.maxHeight,
            maxWidth = settings.maxWidth,
            _settings$lineWidth = settings.lineWidth,
            lineWidth = _settings$lineWidth === undefined ? 0 : _settings$lineWidth,
            _settings$strokeStyle = settings.strokeStyle,
            strokeStyle = _settings$strokeStyle === undefined ? '#ffffff' : _settings$strokeStyle,
            _settings$drawDebug = settings.drawDebug,
            drawDebug = _settings$drawDebug === undefined ? false : _settings$drawDebug;


        return new Text({
            z: z,
            position: position,
            scale: scale,
            text: text,
            font: font,
            fontSize: fontSize,
            fontColor: fontColor,
            align: align,
            textBaseline: textBaseline,
            ySpacing: 0,
            lineWidth: lineWidth, // set to add an outline
            strokeStyle: strokeStyle,
            innerStroke: false,
            pixelStroke: true, // workaround for Cocoon bug
            maxWidth: maxWidth,
            maxHeight: maxHeight,
            linebreaks: true,
            drawDebug: drawDebug,
            components: []
        });
    };
});