'use strict';

bento.define('entities/gui/hintbutton', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/components/sprite', 'bento/components/clickable', 'bento/entity', 'bento/eventsystem', 'entities/gui/gamecounter', 'entities/gui/gamebutton', 'entities/gui/gametext', 'bento/gui/text', 'bento/utils', 'bento/screen', 'bento/tween', 'globals', 'bento/components/fill', 'bento/components/eventlistener', 'components/wiggle', 'entities/gui/hintline'], function (Bento, Vector2, Rectangle, Sprite, Clickable, Entity, EventSystem, GameCounter, GameButton, GameText, Text, Utils, Screen, Tween, Globals, Fill, EventListener, Wiggle, HintLine) {
    return function (settings) {
        var viewport = Bento.getViewport();

        var shown = false;

        var behavior = {
            name: 'behavior',
            update: function update() {
                var canHint = Globals.hintsRevealed < Globals.hintsAvailable && Globals.retryCount >= 1 && Globals.sliceCount === 0;
                if (!shown) {
                    if (canHint) {
                        shown = true;
                        new Tween({
                            from: button.position.y,
                            to: 40,
                            in: 20,
                            ease: 'easeOutQuad',
                            onUpdate: function onUpdate(v, t) {
                                button.position.y = v;
                            }
                        });
                    }
                } else {
                    if (!canHint) {
                        shown = false;
                        new Tween({
                            from: button.position.y,
                            to: -20,
                            in: 20,
                            ease: 'easeInQuad',
                            onUpdate: function onUpdate(v, t) {
                                button.position.y = v;
                            }
                        });
                    }
                }
            }
        };

        var button = new GameButton({
            name: 'hintButton',
            position: new Vector2(viewport.width * 0.5, -20),
            float: true,
            imageName: 'hint',
            scale: new Vector2(0.1, 0.1),
            onClick: function onClick() {
                if (shown) {
                    Globals.hintsRevealed++;
                }
            },

            components: [behavior, new Wiggle({})]
        });

        return button;
    };
});