'use strict';

/**
 * A loading spinner.
 * @moduleName LoadingSpinner
 */
bento.define('gui/loadingspinner', ['bento', 'bento/math/vector2', 'bento/components/sprite', 'bento/entity'], function (Bento, Vector2, Sprite, Entity) {
    'use strict';

    var sprSettings = {
        imageName: 'gui/loading',
        originRelative: new Vector2(0.5, 0.5),
        frameCountX: 8,
        frameCountY: 1,
        animations: {
            default: {
                speed: 0.2,
                frames: [0, 1, 2, 3, 4, 5, 6, 7]
            }
        }
    };
    return function (settings) {
        var sprite = new Sprite(sprSettings);
        var entity = new Entity({
            z: settings.z,
            name: settings.name || 'loadingSpinner',
            position: settings.position,
            updateWhenPaused: 1,
            float: settings.float,
            scale: settings.scale || new Vector2(1, 1),
            components: [sprite]
        });
        return entity;
    };
});