'use strict';

bento.define('gui/needstarsdialog', ['bento', 'bento/utils', 'modules/savemanager', 'globals', 'bento/eventsystem', 'gui/dialog', 'gui/gui', 'gui/starcounter', 'modules/textstyles', 'bento/tween', 'modules/localization'], function (Bento, Utils, SaveManager, Globals, EventSystem, Dialog, Gui, StarCounter, TextStyles, Tween, Localization) {

    var NeedStarsDialog = function NeedStarsDialog(settings) {
        var starsNeeded = settings.starsNeeded;


        var dialog = new Dialog({
            name: 'notEnoughStars',
            type: 'ok',
            title: Localization.getText('needStarsTitle').toUpperCase(),
            text: Localization.getText('needStarsBody').replace('{NUMBER}', starsNeeded).toUpperCase(),
            onComplete: function onComplete() {
                Bento.screens.show('screens/levelselect');
            }
        });

        Gui.get('starCounter', function (sc) {
            var sc2 = new StarCounter({
                position: dialog.toLocalPosition(sc.getWorldPosition()),
                fontSettings: TextStyles.get('mainWhite')
            });
            dialog.attach(Tween.TweenBehavior({
                from: 0, to: 1, in: 5,
                onStart: function onStart() {
                    dialog.attach(sc2);
                },
                onUpdate: function onUpdate(v) {
                    sc2.alpha = v;
                }
            }));
        });

        return dialog;
    };

    return NeedStarsDialog;
});