'use strict';

bento.define('gui/starcounter', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/components/sprite', 'bento/components/clickable', 'bento/entity', 'bento/eventsystem', 'bento/gui/text', 'modules/textstyles', 'entities/gui/gamecounter', 'bento/utils', 'bento/screen', 'bento/tween', 'globals', 'bento/components/eventlistener', 'components/simplesprite', 'modules/savemanager', 'modules/levelmanager'], function (Bento, Vector2, Rectangle, Sprite, Clickable, Entity, EventSystem, Text, TextStyles, GameCounter, Utils, Screen, Tween, Globals, EventListener, SimpleSprite, SaveManager, LevelManager) {
    return function (settings) {
        var position = settings.position,
            entity = settings.entity,
            _settings$fontSetting = settings.fontSettings,
            fontSettings = _settings$fontSetting === undefined ? TextStyles.get('main') : _settings$fontSetting;


        if (!entity) {
            entity = new Entity({
                name: 'starCounter',
                position: position
            });
        }

        var icon = new SimpleSprite({
            imageName: 'gui/star-icon',
            position: new Vector2(0, 0),
            scale: new Vector2(0.10, 0.10)
        });

        var text = new Text({
            text: LevelManager.getTotalStars() + '/' + LevelManager.getMaxStars(),
            position: new Vector2(-11, 1),
            scale: new Vector2(0.46, 0.46),
            fontSettings: fontSettings,
            align: 'right',
            maxWidth: 100,
            maxHeight: 32
            // drawDebug: true
        });

        entity.attach(icon);
        entity.attach(text);

        // entity.attach(new EventListener({
        //     eventName: 'updateCoins',
        //     onEvent (value) {
        //         updateCounter(value === undefined ? SaveManager.load('coins') : value);
        //     }
        // }));

        return entity;
    };
});