'use strict';

/**
 * @moduleName Adjust
 */
bento.define('modules/adjust', ['bento', 'bento/utils'], function (Bento, Utils) {
    'use strict';

    var _window = window,
        Adjust = _window.Adjust,
        AdjustConfig = _window.AdjustConfig;


    return {
        init: function init(settings) {
            if (!Adjust) {
                Utils.log('Adjust SDK not found.');
                return;
            }

            var appToken = settings.appToken,
                appSecret = settings.appSecret,
                _settings$isDev = settings.isDev,
                isDev = _settings$isDev === undefined ? Utils.isDev() : _settings$isDev;


            var env = isDev ? AdjustConfig.EnvironmentSandbox : AdjustConfig.EnvironmentProduction;
            var adjustConfig = new AdjustConfig(appToken, env);
            adjustConfig.setAppSecret(appSecret[0], appSecret[1], appSecret[2], appSecret[3], appSecret[4]);
            Adjust.create(adjustConfig);
        }
    };
});