'use strict';

/**
 * Migrate localStorage values
 */
bento.define('modules/migratesavestate', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/entity', 'bento/eventsystem', 'bento/utils', 'bento/tween'], function (Bento, Vector2, Rectangle, Entity, EventSystem, Utils, Tween) {
    'use strict';

    return function (settings) {
        var desiredId = settings.id;
        // call this function before the savestate id is set!
        var currentId = Bento.saveState.getId();

        var i, l;
        var keys = [];
        var value;
        var deletion = [];
        var onKey = function onKey(key) {
            if (key.indexOf(currentId) !== 0) {
                // only migrate the keys that are part of bento
                return;
            }

            value = window.localStorage[key];

            // save as new key
            window.localStorage.setItem(key.replace(currentId, desiredId), value);

            // delete old
            deletion.push(key);
        };

        try {
            // loop through localstorage
            for (i = 0, l = window.localStorage.length; i < l; ++i) {
                // get from localstorage
                keys.push(window.localStorage.key(i));
            }
            // add in a new for loop
            for (i = 0, l = keys.length; i < l; ++i) {
                onKey(keys[i]);
            }
            // delete in a new for loop
            for (i = 0; i < deletion.length; ++i) {
                window.localStorage.removeItem(deletion[i]);
            }
        } catch (e) {
            console.warn('Storage migration failed.', e);
        }
    };
});