'use strict';

bento.define('screens/dummypreloadertest', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/components/sprite', 'bento/components/clickable', 'bento/components/fill', 'bento/gui/text', 'bento/entity', 'bento/eventsystem', 'bento/utils', 'bento/screen', 'bento/tween', 'entities/luckykatlogo', 'globals', 'modules/localization', 'modules/levelmanager', 'modules/notifications', 'modules/savemanager', 'modules/cloudsave', 'gui/uiloader', 'gui/iphonexoverlay', 'modules/admanager', 'modules/vipmanager', 'modules/textstyles', 'components/mask'], function (Bento, Vector2, Rectangle, Sprite, Clickable, Fill, Text, Entity, EventSystem, Utils, Screen, Tween, LuckyKat, Globals, Localization, LevelManager, Notifications, SaveManager, CloudSave, UILoader, IPhoneXOverlay, AdManager, VipManager, TextStyles, Mask) {

    var PIXI = window.PIXI; /**
                             * Screen description
                             */


    var onShow = function onShow() {
        /* Screen starts here */
        var viewport = Bento.getViewport();
        var loaded = false;

        var bgScale = 0.5;
        var bgSprite = new PIXI.extras.TilingSprite(Utils.newTexture('texture/slice-white'), viewport.width / bgScale, viewport.height / bgScale);
        var background = new Entity({
            z: 0,
            name: 'bg',
            float: true,
            scale: new Vector2(bgScale, bgScale),
            components: [{
                name: 'behavior',
                draw: function draw(_ref) {
                    var renderer = _ref.renderer;

                    renderer.drawPixi(bgSprite);
                }
            }]
        });

        var barTexture = Utils.newTexture('temp/loadingbar2');
        var bar = new PIXI.Sprite(barTexture);
        var baseWidth = barTexture.width;
        barTexture.frame.width = 0;

        var loadingBar = new Entity({
            name: 'loadingBar',
            position: new Vector2(-barTexture.width / 2, -barTexture.height / 2),
            components: {
                name: 'behavior',
                draw: function draw(_ref2) {
                    var renderer = _ref2.renderer;

                    renderer.drawPixi(bar);
                }
            }
        });

        var loadStatus = 0;
        var fakeLoad = 0;
        var loadingPercentage = 0;
        var loadDisplay = new Entity({
            z: 0,
            position: new Vector2(viewport.width * 0.5, viewport.height * 0.5 + 10),
            scale: new Vector2(0.16, 0.16),
            components: [new Sprite({
                imageName: 'temp/loadingbar-border',
                originRelative: new Vector2(0.5, 0.5)
            })]
        });

        Bento.objects.attach(background);

        Bento.objects.attach(loadDisplay);
    };

    return new Screen({
        onShow: onShow
    });
});