'use strict';

bento.define('screens/levelselect', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/components/sprite', 'bento/components/clickable', 'bento/entity', 'bento/eventsystem', 'entities/gui/gamecounter', 'entities/gui/gamebutton', 'entities/gui/gametext', 'bento/gui/text', 'bento/utils', 'bento/screen', 'bento/tween', 'globals', 'bento/components/fill', 'bento/components/eventlistener', 'entities/camera', 'modules/particlesystem', 'components/wiggle', 'entities/hintarea', 'entities/gridbg', 'gui/gui', 'gui/guilevelselect', 'bento/gui/scrollinglist', 'modules/textstyles', 'components/debug', 'modules/savemanager', 'modules/levelmanager'], function (Bento, Vector2, Rectangle, Sprite, Clickable, Entity, EventSystem, GameCounter, GameButton, GameText, Text, Utils, Screen, Tween, Globals, Fill, EventListener, Camera, ParticleSystem, Wiggle, HintArea, GridBg, Gui, GuiLevelSelect, ScrollingList, TextStyles, Debug, SaveManager, LevelManager) {

    var PIXI = window.PIXI;

    var onShow = function onShow() {
        var viewport = Bento.getViewport();
        Bento.objects.attach(new GridBg({}));
        // Bento.objects.attach(new Background({}));

        Gui.load({
            assetName: 'ui/levelselect',
            handlers: GuiLevelSelect
        });
    };

    // unused
    var Background = function Background(settings) {
        var viewport = Bento.getViewport();
        var sprite = new PIXI.extras.TilingSprite(Utils.newTexture('texture/solid'), viewport.width, viewport.height);

        var entity = new Entity({
            name: 'background',
            z: Globals.Layers.BACKGROUND,
            position: new Vector2(0, 0),
            components: [new Object({
                name: 'behavior',
                draw: function draw(_ref) {
                    var renderer = _ref.renderer;

                    renderer.drawPixi(sprite);
                }
            })]
        });
        return entity;
    };

    var onHide = function onHide() {};

    return new Screen({
        onShow: onShow,
        onHide: onHide
    });
});