'use strict';

bento.define('screens/settingsmenu', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/components/sprite', 'bento/components/clickable', 'bento/entity', 'bento/eventsystem', 'bento/gui/clickbutton', 'bento/gui/counter', 'bento/gui/text', 'bento/utils', 'bento/screen', 'bento/tween', 'entities/gridbg', 'gui/gui', 'gui/guisettingsmenu', 'modules/crosspromo/crosspromo'], function (Bento, Vector2, Rectangle, Sprite, Clickable, Entity, EventSystem, ClickButton, Counter, Text, Utils, Screen, Tween, GridBg, Gui, GuiSettingsMenu, CrossPromo) {

    var onShow = function onShow() {
        var settings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var fromScreen = settings.fromScreen,
            restore = settings.restore;


        Bento.objects.attach(new GridBg({}));
        Gui.load({
            assetName: 'ui/settingsmenu',
            handlers: GuiSettingsMenu,
            fromScreen: fromScreen, // which screen did we come from?
            restore: restore // did we get here using the back button (in which case fromScreen should be ignored and the old value should be used)
        });
    };

    return new Screen({
        onShow: onShow
    });
});