'use strict';

bento.define('screens/titlescreen', ['bento', 'bento/math/vector2', 'bento/math/rectangle', 'bento/components/sprite', 'bento/components/clickable', 'bento/entity', 'bento/eventsystem', 'bento/gui/clickbutton', 'bento/gui/counter', 'bento/gui/text', 'bento/utils', 'bento/screen', 'bento/tween', 'bento/components/fill', 'entities/gridbg', 'globals', 'modules/savemanager', 'modules/timemanager', 'modules/skinmanager', 'modules/admanager', 'gui/gui', 'gui/guititlescreen', 'gui/vipgiftdialog', 'modules/vipmanager', 'gui/notification', 'gui/askrating', 'modules/cloudsavechecker'], function (Bento, Vector2, Rectangle, Sprite, Clickable, Entity, EventSystem, ClickButton, Counter, Text, Utils, Screen, Tween, Fill, GridBg, Globals, SaveManager, TimeManager, SkinManager, AdManager, Gui, GuiTitleScreen, VipGiftDialog, VipManager, Notification, AskRating, CloudSaveChecker) {
    // importing to register event listener

    var onShow = function onShow(settings) {

        Bento.objects.attach(new GridBg({}));

        Gui.load({
            assetName: 'ui/titlescreen',
            handlers: GuiTitleScreen,

            onComplete: function onComplete() {
                VipManager.checkVip(function (isVip) {
                    if (isVip) {
                        if (SaveManager.load('VipFirstTimeClaim') === false) {
                            SaveManager.save('VipFirstTimeClaim', true);
                            Bento.objects.attach(new VipGiftDialog({
                                gift: VipGiftDialog.getGift(1) // 1 days worth of rewards
                            }));
                        } else {
                            // Give VIP gift if available
                            var gift = VipGiftDialog.getGift();
                            if (gift) {
                                Bento.objects.attach(new VipGiftDialog({ gift: gift }));
                            }
                        }
                        SaveManager.save('lastTimeVipClaimed', TimeManager.getTime());
                    } else {
                        // We don't have a subscription.
                        // Reset chosen character if a VIP character was selected.
                        var char = SkinManager.getCharacterById(SaveManager.load('character'));
                        if (!char || char.vip) {
                            SaveManager.save('character', '1');
                        }
                    }
                });
            }
        });

        Bento.objects.attach({
            name: 'bannerMaker',
            t: 0,
            update: function update() {
                if (this.t++ > 60) {
                    this.t = 0;
                    AdManager.showBanner(); // show if allowed and not already visible.
                }
            }
        });

        Bento.objects.attach(CloudSaveChecker);
    };

    return new Screen({
        onShow: onShow
    });
});